#ifndef _ASYNCPIPE_H_
#define _ASYNCPIPE_H_

#include <qobject.h>
#include <qtimer.h>
#include <qcstring.h>

class AsyncPipe : public QObject
{
	Q_OBJECT
public:
	enum Type{
		Read, Write,
	};

	AsyncPipe(const char* file, Type type, bool temp=FALSE, QObject* parent=0, const char* name=0);
	~AsyncPipe();
private:
	QCString m_file;
	int m_fd;
	Type m_type;
	QTimer* m_pTimer;
	bool m_temp;
private slots:
	void check();
signals:
	void activated(int fd);
	void unactivated();
};

#endif /* _ASYNCPIPE_H_ */
