#include "InputHelperApplet.h"
#include "InputHelperWidget.h"
#include <qfile.h>

InputHelperApplet::InputHelperApplet()
	: widget(0), ref(0)
{
}

InputHelperApplet::~InputHelperApplet()
{
	delete widget;
}

QWidget* InputHelperApplet::applet(QWidget* parent)
{
	if(!widget){
		widget = new InputHelperWidget(parent);
	}
	return(widget);
}

int InputHelperApplet::position() const
{
	return(6);
}

QRESULT InputHelperApplet::queryInterface(const QUuid& uuid,
	QUnknownInterface** iface)
{
	*iface = 0;

	if(QFile::exists("/tmp/disable-inputhelper")
		|| QFile::exists("/mnt/card/disable-inputhelper")
		|| QFile::exists("/mnt/cf/disable-inputhelper")){
		return QS_FALSE;
	}

	if(uuid == IID_QUnknown){
		*iface = this;
	} else if(uuid == IID_TaskbarApplet){
		*iface = this;
	}

	if(*iface){
		(*iface)->addRef();
	}
	return QS_OK;
}

Q_EXPORT_INTERFACE()
{
	Q_CREATE_INSTANCE(InputHelperApplet)
}
